## guitarix 0.46.0+dfsg

=== wscript ===
#! /usr/bin/env python
# encoding: utf-8

import sys, os, re, shutil
from waflib import Context, Build, Utils, Options, Logs, Configure, Scripting, Task
from waflib.Errors import WafError, ConfigurationError
from waflib.TaskGen import extension, taskgen_method, feature, before_method, after_method

# Waf version check, for global waf installs

if Context.WAFVERSION[:3] != '2.0':
    print('Incompatible Waf, use 2.0')
    sys.exit (1)

# these variables are mandatory ('/' are converted automatically)
srcdir = '.'
blddir = 'build'

# used by waf dist and waf build
VERSION='0.46.0'
APPNAME='guitarix'

Options.OptionsContext.gxload = \
    Configure.ConfigurationContext.gxload = \
        Build.BuildContext.gxload = \
            lambda ctx, tool: ctx.load(tool, tooldir='waftools')

check_in_faust_version = '2.69.3'  # this Faust should be used for checked in generated files
other_faust_versions = ['2.37.3', '2.33.1', '2.30.5','2.40.0', '2.54.9', '2.60.3','2.68.1'] # other Faust versions known to work

g_maxlen = 40 # maximum width of message for 2-column display

fontmsg = """
RobotoCondensed font not found: please install the fonts-roboto package from your distribution (recommended)
or use --install-roboto-font to install the included roboto font."""

################################################################
# options defined for waf configure
################################################################

def options(opt):

    def add_enable_option (option, desc, group=None, disable=False):
        if group == None:
            group = opt
        option_ = option.replace ('-', '_')
        group.add_option ('--enable-' + option, action='store_true',
            default=False, help='Enable ' + desc, dest='enable_' + option_)
        group.add_option ('--disable-' + option, action='store_true',
            default=disable, help='Disable ' + desc, dest='disable_' + option_)

    opt.add_option('--with-gcov',action='store_true',help='Use gcov for profiling',default=False)
    opt.load('intltool')

    opt.add_option('--no-standalone',
                    action='store_false',
                    dest='standalone',
                    default=True,
                    help=("Don't build standalone (JACK) application"))

    group = opt.add_option_group ('Localization and documentation', '')
    add_enable_option ('nls', 'native language support', group)

    opt.load('compiler_cxx')

    comp = opt.get_option_group("Configuration options")

    opt.gxload('cpu_optimization')

    comp.add_option('--enable-lfs',
                    action='store_const',
                    default=False,
                    const=True,
                    help='enable Large File Support (LFS)  ')

    comp.add_option('--no-desktop-update',
                    action='store_const',
                    default=False, #'-fomit-frame-pointer -ffast-math -fstrength-reduce -pipe',
                    const=True,
                    help='dont automatically update desktop database')


    opt.recurse('libgxw/gxw')
    opt.recurse('libgxwmm/gxwmm')

    opt.gxload('zita-resampler')
    opt.gxload('zita-convolver')

    comp.add_option('--libdir',
                   type='string',
                   default='',
                   dest='libdir',
                   help=('library install path '),
                   )

    opt.gxload('faust')

    opt.gxload('lv2')
    opt.gxload('robotofont')

    opt.recurse('pygxw')
    opt.recurse('glade-gxw')

    opt.load('compiler_c') # for pygxw and glade-gxw

    opt.add_option('--dist-tree',
                   type='string',
                   dest='dist_tree',
                   help=("option for 'dist' command: git tree-ish to build"
                         " the archive from [Default: %s]" % 'V%s' % VERSION))

    opt.recurse('src/gx_head')
    opt.recurse('src/NAM')
    opt.recurse('src/RTNeural')


################################################################
# waf configure
################################################################

################################################################
# configuration display helper functions
#

def print_msg(msg, nl=True):
    s = sys.stdout
    if nl:
        t = "\n"
    else:
        t = " "
    s.write(msg+t)

# a bit of waf display formatting
@Configure.conf
def display_msg(msg, status = None, color = None):
    sr = msg
    global g_maxlen
    g_maxlen = max(g_maxlen, len(msg))
    if status is not None:
        print_msg("%s :" % msg.ljust(g_maxlen),False)
        Logs.pprint(color, status)
    else:
        print_msg("%s" % msg.ljust(g_maxlen))

@Configure.conf
def display_msg_1(self, msg, status = None, color = None):
    sr = msg
    global g_maxlen
    g_maxlen = max(g_maxlen, len(msg))
    if status is not None:
        print_msg("%s :" % msg.ljust(g_maxlen),False)
        Logs.pprint(color, status)
    else:
        print_msg("%s" % msg.ljust(g_maxlen))

def error_msg(msg):
    Utils.eprint('RED', msg)

def display_feature(msg, build):
    if build:
        display_msg(msg, "yes", 'CYAN')
    else:
        display_msg(msg, "no", 'YELLOW')

################################################################
# configuration utility functions
#

def option_enabled (option):
    if getattr (Options.options, 'enable_' + option):
        return True
    if getattr (Options.options, 'disable_' + option):
        return False
    return True

@Configure.conf
def define_with_env(self, varname, value):
    self.env[varname] = value
    self.define(varname, value)

################################################################
# configuration helper functions
#
def check_boost(conf):
    code="""
    #include <boost/system/error_code.hpp>
    int main() { boost::system::error_code c; }
    """
    msg = "Checking for boost-system "
    conf.check_cxx(msg = msg, fragment=code, lib="boost_system", uselib_store="BOOST_SYSTEM", mandatory=1,includes='/opt/local/include', libpath='/opt/local/lib')
    # some boost (>1.49) versions depend on boost-system so we will check for it first
    # and later link against boost_system were boost headers are included.
    boost_atleast_version = 104200
    boost_atleast_vermsg = "1.42"
    code="""
    #include <boost/version.hpp>
    #include <boost/format.hpp>
    #include <boost/thread.hpp>
    #if BOOST_VERSION < %d
    #error
    #endif
    int main(){ return 0; }
    """ % boost_atleast_version
    msg = "Checking for boost >= %s" % boost_atleast_vermsg
    conf.check_cxx(msg = msg, fragment=code, lib="boost_system", mandatory=1)
    #conf.check_cxx(msg = msg, fragment=code, lib="boost_system-mt", mandatory=1,includes='/opt/local/include', libpath='/opt/local/lib')

    msg = "Checking for boost_iostreams >= %s" % boost_atleast_vermsg
    conf.check_cxx(msg = msg, fragment=code, lib=["boost_iostreams","boost_system"], uselib_store="BOOST_IOSTREAMS", mandatory=1)
    #conf.check_cxx(msg = msg, fragment=code, lib=["boost_iostreams","boost_system-mt"], uselib_store="BOOST_IOSTREAMS", mandatory=1, includes='/opt/local/include', libpath='/opt/local/lib')
 
    #try:
    #    conf.check_cxx(
    #        msg = msg % "", fragment=code, lib="boost_thread", uselib_store="BOOST_THREAD",
    #        errmsg="not found, trying boost_thread-mt", mandatory=1)
    #except ConfigurationError:
    #    conf.check_cxx(
    #        msg = msg % "-mt",fragment=code, lib="boost_thread-mt",
    #        uselib_store="BOOST_THREAD", mandatory=1)
    
    # not needed: with boost 1.42 Guitarix doesn't generate code which
    #             references the boost threading lib
    #msg = "Checking for boost_thread%%s >= %s" % boost_atleast_vermsg
    #try:
    #    conf.check_cxx(
    #        msg = msg % "", fragment=code, lib="boost_thread", uselib_store="BOOST_THREAD",
    #        errmsg="not found, trying boost_thread-mt", mandatory=1)
    #except ConfigurationError:
    #    conf.check_cxx(
    #        msg = msg % "-mt",fragment=code, lib="boost_thread-mt",
    #        uselib_store="BOOST_THREAD", mandatory=1)


################################################################
# guitarix waf configuration
#

def configure(conf):
    conf.gxload('submodule')
    conf.gxload('bugfixes')
    opt = Options.options

    if opt.disable_sse and opt.optimization:
        display_msg("configuration error", " cannot use --disable-sse and --optimization together", 'RED')
        sys.exit(1)

    conf.env['SHAREDIR'] = conf.env['PREFIX'] + '/share'

    if 'LINGUAS' in os.environ:
        conf.env['LINGUAS'] = os.environ['LINGUAS']

    platform = Utils.unversioned_sys_platform()
    conf.env['IS_MACOSX'] = platform == 'darwin'
    conf.env['IS_LINUX'] = platform == 'linux' or platform == 'posix'
    conf.env['IS_SUN'] = platform == 'sunos'
    conf.env['IS_MSWIN'] = platform == 'win32'

    if conf.env['IS_LINUX']:
        conf.define ('IS_LINUX', platform )

    if conf.env['IS_MACOSX']:
        conf.define ('IS_MACOSX', platform )

    if conf.env['IS_SUN']:
        conf.define ('IS_SUN', platform )

    if conf.env['IS_MSWIN']:
        conf.define ('IS_MSWIN', platform )

    conf.env['OS'] = platform

    if not opt.disable_nls and opt.standalone :
        conf.load('intltool')
        conf.gxload('intltool_extras')
        if conf.env['INTLTOOL'] and conf.env['MSGFMT']:
            nls = 'yes'
        else:
            if opt.enable_nls:
                Logs.pprint ('RED', 'localization N/A')
                sys.exit (1)
            nls = 'N/A'
            conf.define_with_env('DISABLE_NLS', 1)
    else:
        nls = 'no '
        conf.define_with_env('DISABLE_NLS', 1)
    conf.define ('GETTEXT_PACKAGE', APPNAME)

    nls_flag = int(nls == 'yes')
    conf.define_with_env('ENABLE_NLS', nls_flag)
    # compiler
    conf.load('compiler_cxx')
    conf.gxload('compile-extra')
    if opt.with_gcov:
        conf.find_program('gcov')
        conf.env['CXXFLAGS'] = conf.env['CFLAGS'] = ['-fprofile-arcs', '-ftest-coverage']
        conf.env['LDFLAGS'] = ['-lgcov', '-coverage']
    if opt.python_wrapper or opt.glade_support:
        conf.load('compiler_c')
    # linker flags
    conf.env.append_value('LDFLAGS', opt.ldflags.split())
    conf.env['LINKFLAGS'] = conf.env['LDFLAGS']

    # os specific: common settings
    conf.env['OS_LV2_CXXFLAGS']      = ['-fvisibility=hidden','-Wl,--exclude-libs,ALL']
    conf.env['OS_SNDFILE_CFGFLAGS']  = ['--cflags','--libs','sndfile >= 1.0.17']
    conf.env['OS_CAIRO_CFGFLAGS']    = '--cflags --libs'
    conf.env['OS_RESOURCES_LDFLAGS'] = '-z noexecstack'
    if conf.env['OS'] != 'win32':
        conf.env.append_value('OS_LV2_CXXFLAGS', ['-Wl,-z,relro,-z,now'])
    else:
        # MSWin changes
        conf.env.prepend_value('OS_SNDFILE_CFGFLAGS', ['--static'])
        conf.env['OS_CAIRO_CFGFLAGS']    = '--static %s' % conf.env['OS_CAIRO_CFGFLAGS']
        conf.env['OS_RESOURCES_LDFLAGS'] = '' # no -z options

        conf.env.append_value('DEFINES', ['_USE_MATH_DEFINES=1'])
        # waf always(!) adds "-Wl,-Bdynamic" (SHLIB_MARKER) to the commandline, even for an empty list of dynamic libs.
        # MinGW-gcc automatically links libstdc++ and libgcc_seh dynamically, if "-Wl,-Bdynamic" is present.
        # As a workaround, that marker is replaced by an empty string:
        conf.env['SHLIB_MARKER'] = ''
        # "-shared -static" builds a dynamic library which itself is statically linked
        conf.env['LINKFLAGS_cshlib']=['-shared','-static']
        conf.env['LINKFLAGS_cxxshlib']=['-shared','-static']
        conf.check(features='cxx cxxshlib', lib=['pthread'], uselib_store='PTHREAD')

    # needed libraries
    conf.check_cfg(package='sndfile', args=conf.env['OS_SNDFILE_CFGFLAGS'], uselib_store='SNDFILE', mandatory=1)
    conf.check(header_name='fftw3.h', mandatory=1)
    conf.check_cfg(package='fftw3f', args=['--cflags','--libs','fftw3f >= 3.3.8'], uselib_store='FFTW3', mandatory=1)

    if opt.standalone:
        try:

=== glade-gxw/wscript ===
# -*- python -*-
# -*- coding: utf-8 -*-

from waflib import Options

def options(opt):
    grp = opt.get_option_group("Guitarix Widget Library")
    grp.add_option('--glade-support',
                   action='store_const',
                   default=False,
                   const=True,
                   help=('build support for Glade / GtkBuilder (Developers only!!)'),
                   )

def configure(conf):
    if Options.options.glade_support:
        conf.check_cfg(package='gladeui-2.0', variables='catalogdir pixmapdir moduledir', uselib_store='GLADEUI', mandatory=True)
        conf.env.GX_GLADE_SUPPORT = True
        conf.env.GXW_SHARED = True
        conf.env.GXW_SHARED_INSTALL = True

def build(bld):
    if not bld.env.GX_GLADE_SUPPORT:
        return
    bld.recurse("glade-icons")
    bld.shlib(
        ccflags = bld.env.CXXFLAGS,
        use = ['GTK2','gxw'],
        source = ['glade-gxw.c'],
        target = 'gladegx',
        includes = ['..'],
        install_path = bld.env.GLADEUI_moduledir,
        )

    bld.install_files(bld.env.GLADEUI_catalogdir, "gxw.xml", chmod=0o644)

=== libgxwmm/wscript ===
#! /usr/bin/env python
# encoding: utf-8

def configure(conf):
    conf.recurse('gxwmm');

def build(bld):
    env = bld.env
    if not (env.STANDALONE or env.NEW_LADSPA):
        return
    bld.recurse('gxwmm')
    if env.NEW_LADSPA:
        return
    bld.add_group()
    prog = bld(features = 'cxx cprogram',
               source = 'gxw_demo.cc',
               target = 'gxw_demo',
               use = ['GTKMM','gxwmm'],
               includes = ['.'],
               install_path = None,
               )

=== pygxw/wscript ===
# -*- python -*-
# -*- coding: utf-8 -*-

from waflib import Logs, Options

def options(opt):
    grp = opt.get_option_group("Guitarix Widget Library")
    grp.add_option('--python-wrapper',
                   action='store_const',
                   default=False,
                   const=True,
                   help=('build python wrapper for library (Developers only!!)'),
                   )

def configure(conf):
    if not Options.options.python_wrapper:
        return
    conf.env.GX_PYTHON_WRAPPER = True
    conf.env.GXW_SHARED = True
    conf.env.GXW_SHARED_INSTALL = True
    conf.load('python')
    conf.check_python_headers(features='pyext')
    if conf.env.PYTHON_VERSION[0] != '3':
        raise conf.errors.WafError(
            'need Python version 3; please use "python3 waf configure ..."'
            ' or supply the executable path in environment variable PYTHON')
    conf.check_python_module("numpy")
    conf.check_cfg(package='pygobject-2.0', args='--cflags --libs', uselib_store='PYGOBJECT', mandatory=True)
    conf.check_cfg(package='pygobject-2.0', variables='codegendir', uselib_store='PYGOBJECT', mandatory=True, quiet=True)
    conf.check_cfg(package='pygtk-2.0', args='--cflags --libs', uselib_store='PYGTK', mandatory=True)
    conf.check_cfg(package='pygtk-2.0', variables='defsdir', uselib_store='PYGTK', mandatory=True, quiet=True)
    conf.check_cfg(package='gobject-introspection-1.0', mandatory=True)
    conf.find_program('g-ir-scanner', mandatory=True)
    conf.find_program('g-ir-compiler', mandatory=True)

def build(bld):
    if not bld.env.GX_PYTHON_WRAPPER:
        return
    bld.add_group()
    sources = ["GxTuner.h",
               "GxFastMeter.h",
               "GxWaveView.h",
               "GxRegler.h",
               "GxSelector.h",
               "GxSwitch.h",
               "GxToggleImage.h",
               "GxControlParameter.h",
               "GxIREdit.h",
               "GxRadioButton.h",
               "GxWheel.h",
               "GxWheelVertical.h",
               "GxKnob.h",
               "GxBigKnob.h",
               "GxSmallKnob.h",
               "GxSmallKnobR.h",
               "GxHSlider.h",
               "GxMiniSlider.h",
               "GxVSlider.h",
               "GxEQSlider.h",
               "GxLevelSlider.h",
               "GxPaintBox.h",
               "GxMeterScale.h",
               "GxValueDisplay.h",
               "GxRackTuner.h",
               ]
    glob = lambda n: bld.srcnode.ant_glob('libgxw/gxw/'+n)
    bld.env.LIBRARY='libgxw/gxw/libgxw.so'
    gir_name = "Gxw-0.1.gir"
    bld(name = 'gxw_gir',
        rule = (
            "g-ir-scanner --namespace=Gxw --nsversion=0.1 --library ${LIBRARY}"
	    "  --symbol-prefix=gx_ --symbol-prefix=gxw_ --identifier-prefix=Gx"
	    "  $(pkg-config gtk+-3.0 --cflags --libs)"
	    "  -Llibgxw/gxw -lgxw"
	    "  --include Gtk-3.0"
	    "  --output=${TGT}"
            "  ${SRC}"
            ),
        source = glob('gxinit.*')+glob('Gx*.cpp')+glob('Gx*.h'),
        target = gir_name,
        )
    bld(name = 'gxw_typelib',
        rule = 'g-ir-compiler ${SRC} --output=${TGT}',
        source = gir_name,
        target = gir_name.replace('.gir','.typelib'),
        )

=== rcstyles/wscript ===
#!/usr/bin/env python
# encoding: utf-8

import re, os
from waflib import TaskGen, Logs
from waflib.Build import INSTALL, UNINSTALL

scss_theme_files = [
    'gx_head_Guitarix.scss',
    'gx_head_Copper.scss',
    'gx_head_Lavender.scss',
    'gx_head_Sky.scss',
    'gx_head_Olive.scss',
    'gx_head_Hippie.scss',
    'gx_head_Psycedelic.scss',
    'gx_head_Grandma.scss',
    'gx_head_Grungy_Sun_Dark.scss',
    'gx_head_Grungy_Sun.scss',
    'gx_head_Aluminium.scss',
    'gx_head_Oak.scss',
    'gx_head_Burl.scss',
    'gx_head_White_Oak.scss',
    'gx_head_Guitarix_Oak.scss',
    'gx_head_Plain_Dark.scss',
    'gx_head_Dark.scss',
    'gx_head_Nebula.scss',
    'gx_head_Camouflage.scss',
    'gx_head_Orange.scss',
    'gx_head_Rust.scss',
    'gx_head_Gold.scss',
    ]

scss_additional_files = [
    'minimal.scss',
    ]

gxstyle_files = [
    'clear.css',
    'background1.png',
    'background2.png',
    'live_wallpaper_aluminium.png',
    'live_wallpaper_camouflage.png',
    'live_wallpaper_copper.png',
    'live_wallpaper_dark.png',
    'live_wallpaper.png',
    'live_wallpaper_guitarix_oak.png',
    'live_wallpaper_lavender.png',
    'live_wallpaper_oak.png',
    'live_wallpaper_olive.png',
    'live_wallpaper_orange.png',
    'live_wallpaper_sky.png',
    'live_wallpaper_white_oak.png',
    'live_wallpaper_burl.png',
    'live_wallpaper_psycedelic.png',
    'live_wallpaper_hippie.png',
    'live_wallpaper_grungy_sun.png',
    'live_wallpaper_grungy_sun_dark.png',
    'live_wallpaper_grandma.png',
    'live_wallpaper_nebula.png',
    'live_wallpaper_rust.png',
    'live_wallpaper_gold.png',

    'tactile_knob_large_151f.png',
    'tactile_knob_small_99f.png',
    'tactile_knob_medium_151f.png',
    'tactile_wheel_101f.png',

    'stereo.png',
    'live_bypass.png',
    'factory.png',
    'live_mute.png',
    'readonly.png',
    'scratch.png',
    'versiondiff.png',
    'playhead.png',
    'simplelevelslider.png',

    'switch_on.png',
    'switch_mid_off.png',
    'switch_mid_on.png',
    'switch_off.png',
    'rack_expand.png',
    'rack_shrink.png',
    'rack_preset.png',
    'insert.png',
    'hslider.png',
    'logo.png',
    'logo_orange.png',
    'logo_white.png',
    'handle_left.png',
    'handle_right.png',

    # knobs
    'knob_small.png',
    'knob_small_r.png',
    'knob_mid.png',
    'knob_big.png',

    ###COPPER THEME
    'copper.png',

    ###LAVENDER THEME
    'lavender.png',

    ###SKY THEME
    'sky.png',

    ###OLIVE THEME
    'olive.png',

    ###HIPPIE THEME
    'hippie.png',
    'hippie2.png',
    'knob_small_hippie.png',
    'knob_small_r_hippie.png',
    'knob_mid_hippie.png',
    'knob_big_hippie.png',

    ###PSYCEDELIC THEME
    'psycedelic.png',

    ###GRANDMA THEME
    'grandma.png',

    ###GRUNGY SUN THEME
    'grungy_sun_dark.png',
    'grungy_sun_dark2.png',

    ###GRUNGY SUN THEME
    'grungy_sun.png',
    'grungy_sun2.png',

    ###ALUMINIUM THEME
    'aluminium1.png',
    'aluminium2.png',

    ###OAK THEME
    'oak1.png',
    'oak2.png',

    ###BURL THEME
    'burl1.png',
    'burl2.png',

    ###WHITE OAK THEME
    'oak_white.png',
    #'oak2.png',

    ###GUITARIX OAK THEME
    'oak_green.png',
    #'oak2.png',

    ###DARK THEME
    'dark.png',

    ###NEBULA THEMA
    'nebula.png',
    'nebula2.png',

    ###CAMOUFLAGE THEME
    'camouflage.png',

    ###ORANGE THEME
    'orange.png',

    ###RUST THEME
    'rust.png',
    'rust2.png',

    ###GOLD THEME
    'gold1.png',
    'gold2.png',

     ]

def configure(conf):
    conf.env.SASSC_ARGS = '-ltexpanded' if conf.options.debug else '-tcompressed'

def build(bld):
    if not bld.env.STANDALONE:
        return
    full_rcstyle_dir = True # set to use "guitarix --style-dir build/rcstyles"
    features = []
    if full_rcstyle_dir:
        bld(features='subst',
            source=gxstyle_files,
            target=gxstyle_files,
            is_copy=True,
            install_path=bld.env.GX_STYLE_DIR)
        features.append('generate_symlink_icons')
    bld(name = 'scss',
        features = features,
        source = scss_theme_files,
        proc_args = bld.env.SASSC_ARGS,
        install_path=bld.env.GX_STYLE_DIR,
        chmod=0o644)
    bld(name = 'scss_add',
        source = scss_additional_files,
        proc_args = bld.env.SASSC_ARGS,
        install_path=bld.env.GX_STYLE_DIR,
        chmod=0o644)

=== src/LV2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

from waflib.Context import g_module

def append_sse_flags():
    cpu_model = None
    x86_flags = None
    try:
        for line in open("/proc/cpuinfo"):
            if cpu_model is None:
                if line.startswith("model name"):
                    cpu_model = line.split(":",1)[1].strip()
            elif x86_flags is None:
                if line.startswith("flags"):
                    x86_flags = line.split(":",1)[1].strip()
            else:
                break
    except IOError:
        pass
    if cpu_model is None or x86_flags is None:
        return False
    if "sse2" in x86_flags:
        return True
    else:
        return False

subdirs = [
    'gx_amp.lv2',
    'gx_amp_stereo.lv2',
    'gxautowah.lv2',
    'gxbooster.lv2',
    'gx_chorus.lv2',
    'gx_compressor.lv2',
    'gx_delay.lv2',
    'gxechocat.lv2',
    'gx_echo.lv2',
    'gx_expander.lv2',
    'gx_flanger.lv2',
    'gxmetal_amp.lv2',
    'gxmetal_head.lv2',
    'gx_phaser.lv2',
    #'gxpreamp.lv2',
    #'gxpreamp.lv2/StereoAmp',
    'gx_redeye.lv2',
    'gx_reverb.lv2',
    'gx_studiopre.lv2',
    'gx_studiopre_st.lv2',
    'gxtilttone.lv2',
    'gx_tremolo.lv2',
    'gxts9.lv2',
    'gxtubedelay.lv2',
    'gxtubetremelo.lv2',
    'gxtubevibrato.lv2',
    'gxtuner.lv2',
    'gx_zita_rev1.lv2',
    'gx_mbdistortion.lv2',
    'gx_mbdelay.lv2',
    'gx_mbecho.lv2',
    'gx_mbcompressor.lv2',
    'gx_fuzz.lv2',
    'gx_graphiceq.lv2',
    'gx_duck_delay.lv2',
    'gx_duck_delay_st.lv2',
    'gx_barkgraphiceq.lv2',
    'gx_detune.lv2',
    'gx_shimmizita.lv2',
    'gx_switched_tremolo.lv2',
    'gx_room_simulator.lv2',
    'gx_digital_delay.lv2',
    'gx_digital_delay_st.lv2',
    'gx_livelooper.lv2',
    'gx_mbreverb.lv2',
    'gx_jcm800pre.lv2',
    'gx_jcm800pre_st.lv2',
    'gx_cabinet.lv2',
    #'gx_vibe.lv2',
    'gx_fuzzface.lv2',
    'gx_fuzzfacefm.lv2',
    'gx_hfb.lv2',
    'gx_hornet.lv2',
    'gx_muff.lv2',
    'gx_scream.lv2',
    'gx_susta.lv2',
    'gx_cstb.lv2',
    'gx_fumaster.lv2',
    'gx_oc_2.lv2',
    'gx_mole.lv2',
    'gx_rangem.lv2',
    'gx_hogsfoot.lv2',
    'gx_colwah.lv2',
    'gx_gcb_95.lv2',
    'gx_aclipper.lv2',
    'gx_bmp.lv2',
    'gx_bossds1.lv2',
    'gx_mxrdist.lv2',
    'gxtape.lv2',
    'gxtape_st.lv2',
    'gx_alembic.lv2',
    'gx_w20.lv2',
]

def configure(conf):
    if not conf.env.NOSSE:
        conf.env.SSE2 = append_sse_flags()

    for x in subdirs:
        conf.recurse(x);
    conf.recurse('xputty/resources')
    conf.recurse('xputty');

def build(bld):
    if not bld.env.LV2:
        return

    bld.recurse('faust')
    bld.recurse('xputty/resources')
    bld.add_group()
    bld.recurse('xputty')
    bld.add_group()
    bld.objects(name='GX_CONVOLVER',
                source='DSP/gx_convolver.cc',
                includes='DSP',
                cxxflags=['-fvisibility=hidden','-fPIC','-Wl,--exclude-libs,ALL'],
                use=['ZITA_CONVOLVER','GX_RESAMPLER'],
    )
    bld.objects(name='GX_RESAMPLER',
                source='DSP/gx_resampler.cc',
                cxxflags=['-fvisibility=hidden','-fPIC','-Wl,--exclude-libs,ALL'],
                use=['ZITA_RESAMPLER'],
    )

    lib_ext = '.so'
    if bld.env.MODGUI:
        sub_list = [('@LIB_EXT@', lib_ext)]
    else:
        sub_list = [('@LIB_EXT@', lib_ext),
                    (',\n        <modgui.ttl> ', ' '),
                    (', <modgui.ttl>', ' '),
                    (', <modguis.ttl>', ' '),
                    ]
    for x in subdirs:
        bld(rule     = g_module.sub_file,
            source   = '%s/manifest.ttl.in' % x,
            target   = '%s/manifest.ttl' % x,
            sub_list = sub_list,
            install_path = '${LV2DIR}/%s' % x,
        )
    bld.recurse(subdirs)

   # if bld.env['LV2GUI']:
   #     gx_ampstyledir = bld.path.find_dir( 'GUI' )
   #     bld.install_files(bld.env.GX_LV2_STYLE_DIR, gx_ampstyledir.ant_glob('**/*.png'),cwd=gx_ampstyledir, chmod=0o644, relative_trick=True)
   #     bld.install_files(bld.env.GX_LV2_STYLE_DIR, gx_ampstyledir.ant_glob('**/*.rc'),cwd=gx_ampstyledir, chmod=0o644, relative_trick=True)

=== src/NAM/wscript ===
#!/usr/bin/env python
# encoding: utf-8

from waflib import Task, Options, Logs
from waflib.TaskGen import extension
import shutil, os

#import sys, ctypes
#from waflib import TaskGen

def options(opt):
    pass

def build(bld):

    src = [
        './NeuralAmpModelerCore/NAM/activations.cpp',
        './NeuralAmpModelerCore/NAM/convnet.cpp',
        './NeuralAmpModelerCore/NAM/dsp.cpp',
        './NeuralAmpModelerCore/NAM/get_dsp.cpp',
        './NeuralAmpModelerCore/NAM/lstm.cpp',
        './NeuralAmpModelerCore/NAM/util.cpp',
        './NeuralAmpModelerCore/NAM/wavenet.cpp',
        ]

    incl = ['../headers', '..',
        './NeuralAmpModelerCore/NAM/',
        './NeuralAmpModelerCore/Dependencies/eigen/',
        './NeuralAmpModelerCore/Dependencies/nlohmann/',
        ]

    cxx_flags = ["-std=c++17", "-Wno-sign-compare", "-Ofast"]

    if not bld.env['LTO']:
        cxx_flags.append ("-fno-fat-lto-objects")

    bld.stlib(
        name = 'libnam',
        includes = incl,
        export_includes=['..'],
        source = src,
        use = [],
        cxxflags = cxx_flags,
        target = 'nam',
        )

=== src/gx_head/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import sys
from waflib import Task, Options, Logs
from waflib.TaskGen import extension
import os, shutil

def options(opt):
    guitarix_prog = opt.add_option_group("Guitarix Program Options")
    guitarix_prog.add_option(
        '--no-avahi', action='store_const', default=False, const=True,
        help=('Do not build with avahi support for automatic discovery of'
              ' / connection to Guitarix server instances  [Default: no]'))
    guitarix_prog.add_option(
        '--no-bluez', action='store_const', default=False, const=True,
        help=('Do not build with bluez support for remote'
              ' / connection to Guitarix server instances  [Default: no]'))
    guitarix_prog.add_option(
        '--no-nsm', action='store_const', default=False, const=True,
        help=('Do not build with nsm support for remote'
              ' / connection to NSM server instances  [Default: no]'))
    guitarix_prog.add_option(
        '--jack-session', action='store_const', default=False, const=True,
        help=('Try to build with jack session support  [Default: no]'))

def configure(conf):
    if not Options.options.no_avahi:
        conf.check_cfg(package='avahi-gobject', args='--cflags --libs', uselib_store='AVAHI_GOBJECT', mandatory=1)
        conf.check_cfg(package='avahi-glib', args='--cflags --libs', uselib_store='AVAHI_GLIB', mandatory=1)
        conf.check_cfg(package='avahi-client', args='--cflags --libs', uselib_store='AVAHI_CLIENT', mandatory=1)
        conf.env.HAVE_AVAHI = 1
        conf.define("HAVE_AVAHI", 1)
    if not Options.options.no_bluez:
        conf.check_cfg(package='bluez', args='--cflags --libs', uselib_store='BLUEZ', mandatory=0)
    if not Options.options.no_nsm:
        conf.check_cfg(package='liblo', args='--cflags --libs', uselib_store='LIBLO', mandatory=0)

def gperf2cc(task):
    def generated(node):
        name = node.name.replace('.','-generated.')
        return node.parent.find_or_declare([name]).get_src().abspath()
    if task.env.HAVE_GPERF:
        # task.proc.bldpath() triggers bug in Waf 2.0.19 when logging is active
        cmd = [task.proc.abspath()] + [n.bldpath() for n in task.inputs + task.outputs]
        Logs.debug("runner: system command -> %s" % cmd)
        ret = task.exec_command(cmd, shell=False)
        for out in task.outputs:
            shutil.copy2(out.abspath(), generated(out))
        return ret
    else:
        for out in task.outputs:
            shutil.copy2(generated(out), out.abspath())
        return 0

Task.task_factory(
    'gperf',
    gperf2cc,
    color='BLUE',
    before='cxx',
    )

@extension('.gperf_tmpl')
def process_gperf_tmpl(self, node):
    cc_node = node.change_ext('.cc')
    h_node = node.change_ext('.h')
    task = self.create_task('gperf', [node], [cc_node, h_node])
    p = "tools/make_jsonrpc_methods"
    task.proc = self.bld.srcnode.find_resource(p)
    self.bld.add_manual_dependency(node, task.proc)

def build(bld):
    if not (bld.env.STANDALONE or bld.env.NEW_LADSPA):
        return

    sources_engine_shared = [
        'engine/gx_json.cpp',
        'engine/gx_faust_plugins.cpp',
        'engine/gx_internal_plugins.cpp',
        'engine/gx_engine_audio.cpp',
        'engine/gx_paramtable.cpp',
        'engine/gx_convolver.cpp',
        'engine/gx_resampler.cpp',
        'engine/gx_system.cpp',
        'engine/gx_logging.cpp',
        'engine/gx_pluginloader.cpp',
        ]
    sources_engine = [
        './engine/ladspaplugin.cpp',
        './engine/ladspaback.cpp',
        './engine/tunerswitcher.cpp',
        './engine/jsonrpc.cpp',
        './engine/gx_jack.cpp',
        './engine/gx_preset.cpp',
        './engine/gx_internal_ui_plugins.cpp',
        './engine/gx_pitch_tracker.cpp',
        './engine/gx_engine.cpp',
        './engine/jsonrpc_methods.gperf_tmpl',
        ]

    sources_gui = [
        './gui/machine.cpp',
        './gui/ladspalist.cpp',
        './gui/gx_stackbox_builder.cpp',
        './gui/gx_main_window.cpp',
        './gui/liveplay.cpp',
        './gui/rack.cpp',
        './gui/gx_preset_window.cpp',
        './gui/gx_jack_options.cpp',
        './gui/gx_ui_builder.cpp',
        './gui/gx_gui_helpers.cpp',
        './gui/gx_child_process.cpp',
        './gui/gx_main_midi.cpp',
        './gui/gx_jconv_settings.cpp',
        './gui/gx_sequencer_settings.cpp',
        './gui/gxw_mm_controllers.cpp',
        './gui/gx_main_boxes.cpp',
        './gui/gx_portmap.cpp',
        './gui/gx_main.cpp',
        ]

    builder_files = [
        './builder/midi.glade',
        './builder/midi_channel.glade',
        './builder/ports.glade',
        './builder/iredit.glade',
        './builder/iredit_mono.glade',
        './builder/jackstarter.glade',
        './builder/mainpanel.glade',
        './builder/ampbox.glade',
        './builder/liveplay.glade',
        './builder/ladspaliste.glade',
        './builder/crybaby_ui.glade',
        './builder/wah_ui.glade',
        './builder/vibe_ui.glade',
        './builder/vibe_stereo_ui.glade',
        './builder/reversedelay_ui.glade',
        './builder/gx_distortion_ui.glade',
        './builder/gx_record_ui.glade',
        './builder/gx_st_record_ui.glade',
        './builder/gx_detune_ui.glade',
        './builder/abgate_ui.glade',
        './builder/amp.tonestack_ui.glade',
        './builder/ampimpulse_ui.glade',
        './builder/ampimpulse_st_ui.glade',
        './builder/cabinet_ui.glade',
        './builder/cabinet_stereo_ui.glade',
        './builder/jconv_ui.glade',
        './builder/jconv_st_ui.glade',
        './builder/oscilloscope_ui.glade',
        './builder/drumsequencer_ui.glade',
        './builder/dubber_ui.glade',
        './builder/metronome_ui.glade',
        './builder/nam_ui.glade',
        './builder/snam_ui.glade',
        './builder/mnam_ui.glade',
        './builder/rtneural_ui.glade',
        './builder/srtneural_ui.glade',
        './builder/mrtneural_ui.glade',
        './builder/tremolo_ui.glade',
        './builder/pluginpreset_inputwindow.glade',
        './builder/pluginpreset_listwindow.glade',
        './builder/pluginpreset_connectwindow.glade',
        './builder/selectinstance.glade',
        './builder/Sequencer.glade',
        './builder/vumeter_ui.glade',
        './builder/vumeter_st_ui.glade',
        './builder/poweramps_ui.glade',
        './builder/menu.ui',
        './builder/gx_plugins.png',
        './builder/gx_rack.png',
        './builder/gx_show.png',
        './builder/gx_split.png',
        './builder/gx_tuner.png',
        './builder/gx_config.png',
        './builder/gx_fold.png',
        './builder/gx_fullscreen.png',
        ]

    incl = ['.',
            './engine',
            './engine/tabels',
            '../..','..','../headers',
            '../NAM/NeuralAmpModelerCore/NAM/',
            '../NAM/NeuralAmpModelerCore/Dependencies/nlohmann',
            '../NAM/NeuralAmpModelerCore/Dependencies/eigen',
            '../RTNeural/RTNeural/RTNeural/',
            '../RTNeural/RTNeural/modules/Eigen/',
            '../RTNeural/RTNeural/modules/json/',
            ] # need ".." for config.h

    if bld.env.NEW_LADSPA:
        bld(name = 'shared_engine',
            features='cxx',
            cxxflags = bld.env.CXXFLAGS_cxxshlib + ['-DNEW_LADSPA', '-fvisibility=hidden'],
            source = sources_engine_shared,
            includes = incl,
            use = ['GLIBMM','GIOMM','LILV','gxwmm_inc','ZITA_CONVOLVER','ZITA_RESAMPLER'],
            )

    if not bld.env.STANDALONE:
        return

    if bld.env.HAVE_AVAHI:
        sources_gui.append("gui/avahi_discover.cpp")
        sources_engine.append("engine/avahi_register.cpp")
    sources = sources_engine + sources_engine_shared + sources_gui
    uselib = ['JACK', 'SNDFILE', 'GTHREAD', 'GMODULE_EXPORT', 'CURL', 'LIBLO',
              'GTK2', 'GTKMM', 'GIOMM', 'FFTW3', 'LRDF', 'LILV', 'BOOST_SYSTEM','BOOST_IOSTREAMS',
              'ZITA_CONVOLVER','ZITA_RESAMPLER']
    if bld.env.HAVE_AVAHI:
        uselib += ['AVAHI_GOBJECT', 'AVAHI_GLIB', 'AVAHI_CLIENT']
    if bld.env.HAVE_BLUEZ:
        uselib.append('BLUEZ')
    if bld.env.HAVE_PLUGINLIB:
        uselib += ["plugins"]
    uselib += ['gxwmm']
    uselib += ['libnam']
    uselib += ['librtneural']
    bld.program(
        includes = incl,
        source = sources,
        use = uselib,
        target = bld.env.BIN_NAME,
        chmod = 0o755,
        install_path = bld.env.BINDIR,
        ldscript = 'guitarix.lds',
        mapfile = "guitarix.map",
        )
    bld.install_files(bld.env.GX_BUILDER_DIR, builder_files, chmod=0o644)
    if "RUN_DOXYGEN" in os.environ:
        # save source file list and include paths for use by doxygen
        bld(rule="echo ${SRC} > ${TGT}",
            source = [src for src in sources if not src.endswith('.gperf_tmpl')],
            target = 'input_gx_head.txt',
            )
        bld(rule = "echo ${CPPPATH_ST:INCPATHS} > ${TGT}",
            features = "use uselib includes",
            includes = incl,
            use = uselib,
            source = "gui/gx_main.cpp",
            target = 'clang_options.txt',
            )

=== src/LV2/faust/wscript ===
#! /usr/bin/env python
# encoding: utf-8

import shutil 

def build(bld):
    unused_sources = [
        'preamp.dsp',
        'inputgain.dsp',
        'AntiAlias.dsp',
        'HighShelf.dsp',
        'drive.dsp',
        'osc_tube.dsp',
        'reso_tube.dsp',
        'tube.dsp',
        'tube3.dsp',
        'tubevibrato.dsp',
        'multifilter.dsp',
        'eq.dsp',
        'outputgain.dsp',
        'feed.dsp',
        'balance1.dsp',
        'amp2.dsp',
        'stage3.dsp',
        'distortion.dsp',
        'distortion1.dsp',
        'noisegate.dsp',
        'sloop.dsp', ##float
        'vibe_lfo_triangle.dsp',
        'vibe_mono_lfo_triangle.dsp',
        'presence_level.dsp',
        'cabinet_impulse_former.dsp',
        'preamp_impulse_former.dsp',
        'vibe_mono_lfo_sine.dsp',
        'vibe_lfo_sine.dsp',
        ]
    
    # activate mem allocation internal float
    sources_plugin_float = [
        'echo.dsp',
        'delay.dsp',
        'chorus.dsp',
        'stereodelay.dsp',
        'stereoecho.dsp',
        'phaser_mono.dsp',
        'phaser.dsp',
        'crybaby.dsp',
        ]

    # activate mem allocation internal double
    sources_plugin_init = [
        'gxtubedelay.dsp',
        'gxtubevibrato.dsp',
        'gxechocat.dsp',
        'mbdel.dsp',
        'mbe.dsp',
        'gxtape.dsp',
        'gxtape_st.dsp',
        ]

    sources_plugin = [
        'low_high_pass.dsp',
        'selecteq.dsp',
        'autowah.dsp',
        'gx_distortion.dsp',
        'impulseresponse.dsp',
        'compressor.dsp',
        'expander.dsp',
        'overdrive.dsp',
        'freeverb.dsp',
        'biquad.dsp',
        'tremolo.dsp',
        'chorus_mono.dsp',
        'flanger_mono.dsp',
        'gx_feedback.dsp',
        'flanger.dsp',
        'moog.dsp',
        'gx_ampmodul.dsp',
        'tonecontroll.dsp',
        'stereoverb.dsp',
        'softclip.dsp',
        'gx_ampout.dsp',
        'gx_ampout_ladspa.dsp',
        'noise_shaper.dsp',
        'bassbooster.dsp',
        'gx_outputlevel.dsp',
        'gx_outputlevel_ladspa.dsp',
        'gxfeed.dsp',
        'highbooster.dsp',
        'noiser.dsp',
        'stereo_noiser.dsp',
        'gx_zita_rev1.dsp',
        'gx_flanger.dsp',
        'gxtilttone.dsp',
        'gxtubetremelo.dsp',
        'gx_studiopre.dsp',
        'gx_studiopre_st.dsp',
        'low_high_cut.dsp',
        'uniBar.dsp',
        'mbd.dsp',
        'mbc.dsp',
        'mbreverb.dsp',
        'bmfp.dsp',
        'lowpass_up.dsp',
        'lowpass_down.dsp',
        'graphiceq.dsp',
        'duck_delay.dsp',
        'duck_delay_st.dsp',
        'fuzzface.dsp',
        'fuzzfacefm.dsp',
        'hfb.dsp',
        'hornet.dsp',
        'muff.dsp',
        'scream.dsp',
        'susta.dsp',
        'cstb.dsp',
        'fumaster.dsp',
        'hogsfoot.dsp',
        'mole.dsp',
        'rangem.dsp',
        'colwah.dsp',
        'dallaswah.dsp',
        'foxwah.dsp',
        'jenwah.dsp',
        'maestrowah.dsp',
        'selwah.dsp',
        'voxwah.dsp',
        'gcb_95.dsp',
        'aclipper.dsp',
        'bmp.dsp',
        'mxrdist.dsp',
        'bossds1.dsp',
        'gx_alembic.dsp',
        'gx_w20.dsp',
        'switched_tremolo.dsp',

        # tone stacks
        'tonestack_default.dsp',
        'tonestack_bassman.dsp',
        'tonestack_twin.dsp',
        'tonestack_princeton.dsp',
        'tonestack_jcm800.dsp',
        'tonestack_jcm2000.dsp',
        'tonestack_mlead.dsp',
        'tonestack_m2199.dsp',
        'tonestack_ac30.dsp',
        'tonestack_soldano.dsp',
        'tonestack_mesa.dsp',
        'tonestack_jtm45.dsp',
        'tonestack_ac15.dsp',
        'tonestack_peavey.dsp',
        'tonestack_ibanez.dsp',
        'tonestack_roland.dsp',
        'tonestack_ampeg.dsp',
        'tonestack_ampeg_rev.dsp',
        'tonestack_sovtek.dsp',
        'tonestack_bogner.dsp',
        'tonestack_groove.dsp',
        'tonestack_crunch.dsp',
        'tonestack_fender_blues.dsp',
        'tonestack_fender_default.dsp',
        'tonestack_fender_deville.dsp',
        'tonestack_gibsen.dsp',

        # tone stacks stereo
        'tonestack_default_stereo.dsp',
        'tonestack_bassman_stereo.dsp',
        'tonestack_twin_stereo.dsp',
        'tonestack_princeton_stereo.dsp',
        'tonestack_jcm800_stereo.dsp',
        'tonestack_jcm2000_stereo.dsp',
        'tonestack_mlead_stereo.dsp',
        'tonestack_m2199_stereo.dsp',
        'tonestack_ac30_stereo.dsp',
        'tonestack_soldano_stereo.dsp',
        'tonestack_mesa_stereo.dsp',
        'tonestack_jtm45_stereo.dsp',
        'tonestack_ac15_stereo.dsp',
        'tonestack_peavey_stereo.dsp',
        'tonestack_ibanez_stereo.dsp',
        'tonestack_roland_stereo.dsp',
        'tonestack_ampeg_stereo.dsp',
        'tonestack_ampeg_rev_stereo.dsp',
        'tonestack_sovtek_stereo.dsp',
        'tonestack_bogner_stereo.dsp',
        'tonestack_groove_stereo.dsp',
        'tonestack_crunch_stereo.dsp',
        'tonestack_fender_blues_stereo.dsp',
        'tonestack_fender_default_stereo.dsp',
        'tonestack_fender_deville_stereo.dsp',
        'tonestack_gibsen_stereo.dsp',

        # amps
        'gxamp.dsp',
        'gxamp2.dsp',
        'gxamp3.dsp',
        'gxamp4.dsp',
        'gxamp5.dsp',
        'gxamp6.dsp',
        'gxamp7.dsp',
        'gxamp8.dsp',
        'gxamp9.dsp',
        'gxamp10.dsp',
        'gxamp11.dsp',
        'gxamp12.dsp',
        'gxamp13.dsp',
        'gxamp14.dsp',
        'gxamp15.dsp',
        'gxamp16.dsp',
        'gxamp17.dsp',
        'gxamp18.dsp',
        'gxnoamp.dsp',
        'gx_chump.dsp',
        'gx_bigchump.dsp',
        'gx_vibrochump.dsp',
        'gxmetal_head.dsp',
        'gxmetal_amp.dsp',

        # stereo amps
        'gxamp_stereo.dsp',
        'gxamp2_stereo.dsp',
        'gxamp3_stereo.dsp',
        'gxamp4_stereo.dsp',
        'gxamp5_stereo.dsp',
        'gxamp6_stereo.dsp',
        'gxamp7_stereo.dsp',
        'gxamp8_stereo.dsp',
        'gxamp9_stereo.dsp',
        'gxamp10_stereo.dsp',
        'gxamp11_stereo.dsp',
        'gxamp12_stereo.dsp',
        'gxamp13_stereo.dsp',
        'gxamp14_stereo.dsp',
        'gxamp15_stereo.dsp',
        'gxamp16_stereo.dsp',
        'gxamp17_stereo.dsp',
        'gxamp18_stereo.dsp',
        'gxnoamp_stereo.dsp',

        # bypass mode
        'balance.dsp',
        ]

    sources_gx_plugin = [

        # 'graphiceq.dsp',
        ]


    if bld.env['FAUST']:
        for x in sources_gx_plugin:
            shutil.copy('src/faust/%s' % x, 'src/LV2/faust/%s' % x)

        arg, float_arg, double_arg = bld.get_faust_args()
        bld(
            source = sources_plugin,
            proc = "../tools/dsp2cc",
            proc_args = arg+["--init-type=plugin-lv2"],
            )
        bld(
            source = sources_gx_plugin,
            proc = "../tools/dsp2cc",
            proc_args = arg+["--init-type=plugin-lv2"],
            )
        bld(
            source = sources_plugin_init,
            proc = "../tools/dsp2cc",
            proc_args = arg+["-s","40000","--init-type=plugin-lv2"],
            )
        bld(
            source = sources_plugin_float,
            proc = "../tools/dsp2cc",
            proc_args = float_arg+["--init-type=plugin-lv2"]
            )
    else:
        gdir = "../faust-generated/"
        for s in sources_plugin_float + sources_plugin + sources_plugin_init:
            s = s.replace(".dsp",".cc")
            bld(name = "copy-faust-cc",
                rule = "cp ${SRC} ${TGT}",
                source = gdir + s,
                target = s,
                )
    bld.add_group()

def configure(conf):
    pass

=== src/LV2/gx_aclipper.lv2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

def configure(conf):
    pass

def build(bld):
    lv2_base = 'gx_aclipper'

    bld.lv2(
        lv2_base = lv2_base,
        source   = ['gx_aclipper.cpp'],
        includes = ['../faust','./', '../DSP'],
        cxxflags=['-fvisibility=hidden','-Wl,-z,noexecstack','-Wl,-z,relro,-z,now','-Wl,--exclude-libs,ALL'],
        use = ['LV2CORE','GX_RESAMPLER'],
        )
    bld.lv2_gui(
        lv2_base = lv2_base,
        source   = ' gx_aclipper_ui.cpp',
        includes = ['../xputty/header','../xputty/header/widgets','../xputty/resources','../xputty/lv2_plugin'],
        cxxflags=['-fvisibility=hidden','-Wl,-z,noexecstack','-Wl,-z,relro,-z,now','-Wl,--exclude-libs,ALL'],
        use = ['xcairo','X11', 'CAIRO','LV2CORE'],
        )

=== src/LV2/gx_amp.lv2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

def configure(conf):
    pass

def build(bld):
    lv2_base = 'gx_amp'

    bld.lv2(
        lv2_base = lv2_base,
        source   = ['gxamp.cpp', 'gx_amp.cc', 'gx_tonestack.cc'],
        includes = ['../faust','./', '../DSP', '../DSP/tube_tables'],
        cxxflags=['-fvisibility=hidden','-fno-lto','-Wl,-z,noexecstack','-Wl,-z,relro,-z,now','-Wl,--exclude-libs,ALL'],
        use = ['LV2CORE','GX_CONVOLVER'],
        ldscript = 'gx_amp.lds',
        mapfile = "gx_amp.map",
        )
    bld.lv2_gui(
        lv2_base = lv2_base,
        source   = ' gxamp_ui.cpp',
        includes = ['../xputty/header','../xputty/header/widgets','../xputty/resources','../xputty/lv2_plugin'],
        cxxflags=['-fvisibility=hidden','-Wl,-z,noexecstack','-Wl,-z,relro,-z,now','-Wl,--exclude-libs,ALL'],
        use = ['xcairo','X11', 'CAIRO','LV2CORE'],
        )

=== src/LV2/gx_amp_stereo.lv2/wscript ===
#!/usr/bin/env python
# encoding: utf-8

def configure(conf):
    pass

def build(bld):
    lv2_base = 'gx_amp_stereo'

    bld.lv2(
        lv2_base = lv2_base,
        source   = ['gxamp_stereo.cpp', 'gx_amp_stereo.cc', 'gx_tonestack_stereo.cc'],
        includes = ['../faust','./', '../DSP', '../DSP/tube_tables'],
        cxxflags=['-fvisibility=hidden','-fno-lto','-Wl,-z,noexecstack','-Wl,-z,relro,-z,now','-Wl,--exclude-libs,ALL'],
        use = ['LV2CORE','GX_CONVOLVER'],
        ldscript = 'gxamp_stereo.lds',
        mapfile = "gxamp_stereo.map",
        )
    bld.lv2_gui(
        lv2_base = lv2_base,
        source   = ' gxamp_stereo_ui.cpp',
        includes = ['../xputty/header','../xputty/header/widgets','../xputty/resources','../xputty/lv2_plugin'],
        cxxflags=['-fvisibility=hidden','-Wl,-z,noexecstack','-Wl,-z,relro,-z,now','-Wl,--exclude-libs,ALL'],
        use = ['xcairo','X11', 'CAIRO','LV2CORE'],
        )

=== debian/changelog ===
guitarix (0.46.0+dfsg-2) unstable; urgency=medium

  * Team upload
  * Stop building glade catalog support

 -- Jeremy Bícha <jbicha@ubuntu.com>  Fri, 15 Aug 2025 13:39:42 -0400

guitarix (0.46.0+dfsg-1) unstable; urgency=medium

  * New upstream version 0.46.0+dfsg
    + Fix segfaults, when creating a preset bank (Closes: #1062831)
  * Development switched to github, update d/copyright and d/watch
  * LADSPA support is dropped, remove ladspa package
  * Drop patches applied by upstream
  * Add libfftw3-dev to B-Ds
  * Bump d/copyright years
  * Refresh *.lintian.overrides, add d/source/lintian-overrides

 -- Dennis Braun <snd@debian.org>  Fri, 29 Mar 2024 17:15:09 +0100

guitarix (0.44.1+dfsg1-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062195

 -- Lukas Märdian <slyon@debian.org>  Wed, 28 Feb 2024 09:01:17 +0000

=== debian/control ===
Source: guitarix
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Víctor Cuadrado Juan <me@viccuad.me>,
 Dennis Braun <snd@debian.org>,
Rules-Requires-Root: no
Build-Depends: dpkg-dev (>= 1.22.5),
 debhelper-compat (= 13),
 fonts-roboto,
 gperf,
 intltool,
 libavahi-gobject-dev,
 libbluetooth-dev [linux-any],
 libboost-dev,
 libboost-iostreams-dev,
 libboost-system-dev,
 libboost-thread-dev,
 libeigen3-dev,
 libfftw3-dev,
 libgtk-3-dev,
 libgtkmm-3.0-dev,
 libjack-dev | libjack-jackd2-dev,
 liblilv-dev,
 liblrdf0-dev,
 libsndfile1-dev,
 libzita-convolver-dev,
 libzita-resampler-dev,
 lv2-dev,
 python3,
 sassc,
Build-Depends-Indep:
 doxygen,
 graphviz,
Standards-Version: 4.6.2
Homepage: https://guitarix.org
Vcs-Git: https://salsa.debian.org/multimedia-team/guitarix.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/guitarix

Package: guitarix
Architecture: any
Depends:
 fonts-roboto,
 guitarix-common (= ${source:Version}),
 guitarix-lv2 (>= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 gvfs-backends,
 jack-capture,
 lame,
 vorbis-tools,
Description: Rock guitar amplifier for JACK
 Guitarix is a rock guitar amplifier for the JACK Audio Connection Kit with
 one input and two outputs. It provides one JACK input port and two JACK output
 ports. It is designed to produce nice thrash/metal/rock/blues guitar sounds.
 Controls for bass, treble, gain, compressor, tube selector, distortion,
 flanger, freeverb, crybaby (wah), etc are available.
 .
 Guitarix is available as a GTK+ interface and the project provides LV2 and
 LADSPA plugins (see the guitarix-lv2 and guitarix-ladspa packages).
 .
 This package provides the standalone application with a GTK+ interface.

Package: guitarix-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Guitarix - Common files
 Guitarix is a rock guitar amplifier for the JACK Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 thrash/metal/rock/blues guitar sounds.
 .
 Guitarix is available as a GTK+ interface and the project provides LV2 and
 LADSPA plugins (see the guitarix-lv2 and guitarix-ladspa packages).
 .
 This package contains Guitarix's Architecture independent files. Examples of
 such shared files are: configuration files, images and sounds.

Package: guitarix-lv2
Architecture: any
Provides:
 lv2-plugin,
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Guitarix - LV2 plugins
 Guitarix is a rock guitar amplifier for the JACK Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 thrash/metal/rock/blues guitar sounds.
 .
 Guitarix is available as a GTK+ interface and the project provides LV2 and
 LADSPA plugins (see the guitarix-lv2 and guitarix-ladspa packages).
 .
 This package contains the LV2 audio plugins that come together with guitarix,
 but can also be used by any other LV2 host.

Package: guitarix-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 libjs-jquery,
 ${misc:Depends},
Suggests:
 guitarix,
Description: Guitarix - Development documentation
 Guitarix is a rock guitar amplifier for the JACK Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 thrash/metal/rock/blues guitar sounds.
 .
 Guitarix is available as a GTK+ interface and the project provides LV2 and
 LADSPA plugins (see the guitarix-lv2 and guitarix-ladspa packages).
 .
 This package contains Guitarix's Development documentation.

Package: libgxw0t64
Provides: ${t64:Provides}
Replaces: libgxw0
Breaks: libgxw0 (<< ${source:Version})
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Guitarix - GTK+ library
 Guitarix is a rock guitar amplifier for the JACK Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 thrash/metal/rock/blues guitar sounds.
 .
 Guitarix is available as a GTK+ interface and the project provides LV2 and
 LADSPA plugins (see the guitarix-lv2 and guitarix-ladspa packages).
 .
 This package contains Guitarix's GTK+ library.

Package: libgxw-dev
Section: libdevel
Architecture: any
Depends:
 libgxw0t64 (= ${binary:Version}),
 ${misc:Depends},
Recommends:
 guitarix-doc,
Description: Guitarix - GTK+ library (development files)
 Guitarix is a rock guitar amplifier for the JACK Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 thrash/metal/rock/blues guitar sounds.
 .
 Guitarix is available as a GTK+ interface and the project provides LV2 and
 LADSPA plugins (see the guitarix-lv2 and guitarix-ladspa packages).
 .
 This package contains development files for Guitarix's GTK+ library.

Package: libgxwmm0t64
Provides: ${t64:Provides}
Replaces: libgxwmm0
Breaks: libgxwmm0 (<< ${source:Version})
Section: libs
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Guitarix - GTK+ C++ widget library
 Guitarix is a rock guitar amplifier for the JACK Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 thrash/metal/rock/blues guitar sounds.
 .
 Guitarix is available as a GTK+ interface and the project provides LV2 and
 LADSPA plugins (see the guitarix-lv2 and guitarix-ladspa packages).
 .
 This package contains Guitarix's GTK+ C++ widget library.

Package: libgxwmm-dev
Section: libdevel
Architecture: any
Depends:
 libgxwmm0t64 (= ${binary:Version}),
 ${misc:Depends},
Recommends:
 guitarix-doc,
Description: Guitarix - GTK+ C++ widget library (development files)
 Guitarix is a rock guitar amplifier for the JACK Audio Connection Kit with
 one input and two outputs. It is designed to produce nice
 thrash/metal/rock/blues guitar sounds.
 .
 Guitarix is available as a GTK+ interface and the project provides LV2 and
 LADSPA plugins (see the guitarix-lv2 and guitarix-ladspa packages).
 .
 This package contains development files for Guitarix's GTK+ C++ widget library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
	NUMJOBS = 1
endif

%:
	dh $@

override_dh_auto_configure:
	python3 ./waf configure --prefix=/usr --no-faust \
		--cxxflags="$(shell dpkg-buildflags --get CXXFLAGS) \
			$(shell dpkg-buildflags --get CPPFLAGS)" \
		--ldflags="$(shell dpkg-buildflags --get LDFLAGS)" -v \
		--shared-lib --lib-dev --enable-lfs --disable-sse

override_dh_makeshlibs:
	dh_makeshlibs -V

override_dh_auto_build-arch:
	python3 ./waf build -v --jobs=$(NUMJOBS)

override_dh_auto_build-indep:
	cd $(CURDIR)/documentation ; doxygen Doxyfile.in
	# don't use dh_doxygen because it doesn't detect the docs
	cd $(CURDIR)/html && find . -name "*.md5" -delete
	cd $(CURDIR)/html && find . -name "*.map" -delete

override_dh_auto_clean:
	python3 ./waf distclean
	rm -rf build/*
	rm -rf build/.conf*
	rm -rf build/.waf*
	find . -name "*.pyc" -delete
	rm -rf html

override_dh_auto_install:
	python3 ./waf install --destdir=$(CURDIR)/debian/tmp --libdir=$(CURDIR)/debian/tmp
	rm -f $(CURDIR)/debian/tmp/usr/share/gx_head/sounds/bands/LICENSE
	rm -f $(CURDIR)/debian/tmp/usr/share/gx_head/sounds/amps/LICENSE
	rm -f $(CURDIR)/debian/tmp/usr/lib/libgxwmm.so
	rm -f $(CURDIR)/debian/tmp/usr/lib/libgxw.so
	ln -s libgxwmm.so.0.1 $(CURDIR)/debian/tmp/usr/lib/libgxwmm.so
	ln -s libgxw.so.0.1 $(CURDIR)/debian/tmp/usr/lib/libgxw.so
